module Pod
  class Command
    # This is an example of a cocoapods plugin adding a top-level subcommand
    # to the 'pod' command.
    #
    # You can also create subcommands of existing or new commands. Say you
    # wanted to add a subcommand to `list` to show newly deprecated pods,
    # (e.g. `pod list deprecated`), there are a few things that would need
    # to change.
    #
    # - move this file to `lib/pod/command/list/deprecated.rb` and update
    #   the class to exist in the the Pod::Command::List namespace
    # - change this class to extend from `List` instead of `Command`. This
    #   tells the plugin system that it is a subcommand of `list`.
    # - edit `lib/cocoapods_plugins.rb` to require this file
    #
    # @todo Create a PR to add your plugin to CocoaPods/cocoapods.org
    #       in the `plugins.json` file, once your plugin is released.
    #
    class InstallCI < Command
      self.summary = 'Pod install, but have special optimizing for CI to speed up the install process.'

      self.description = <<-DESC
        Pod install, but have special optimizing for CI to speed up the install process.
        It will exclude the header files in the xcode project.
      DESC


      def initialize(argv)
        super
        @install_command = Command::Install.new(argv)
      end


      def run
        require 'cocoapods-fast-install/Patch'
        require 'cocoapods-fast-install/validate_patch'
        @install_command.run
      end

    end
  end
end
