


# prints the durations

module Pod
  class Installer

    class << self

      def count_seconds(method)
        old_method = instance_method(method)
        define_method(method) do |*args|
          start = Time.new
          result = old_method.bind(self).(*args)
          ends = Time.new
          puts "[Fast Install] #{method} spends #{ends - start} seconds"
          next result
        end
      end

    end

    count_seconds :install!

    count_seconds :prepare
    count_seconds :resolve_dependencies
    count_seconds :download_dependencies
    count_seconds :validate_targets
    count_seconds :generate_pods_project
    count_seconds :integrate_user_project
    count_seconds :perform_post_install_actions

  end
end

# #print the separated step in generating
# module Pod
#   class Installer
#     class Xcode
#       class PodsProjectGenerator
#
#         class << self
#
#           def count_seconds(method)
#             old_method = instance_method(method)
#             define_method(method) do |*args|
#               start = Time.new
#               result = old_method.bind(self).(*args)
#               ends = Time.new
#               puts "[Fast Install: PodsProjectGenerator] #{method} spends #{ends - start} seconds"
#               next result
#             end
#           end
#
#         end
#
#         if Pod::VERSION.start_with? "1.5"
#           count_seconds :prepare
#           count_seconds :install_file_references
#           count_seconds :install_libraries
#           count_seconds :integrate_targets
#           count_seconds :set_target_dependencies
#         elsif Pod::VERSION.start_with? "1.6"
#           count_seconds :generate!
#
#           # count_seconds :prepare
#           count_seconds :install_file_references
#           count_seconds :install_targets
#           # count_seconds :integrate_targets
#           # count_seconds :wire_target_dependencies
#         end
#
#       end
#     end
#   end
# end

def print_duration(description, &block)
  start = Time.new
  result = block.call() if block_given?
  stop = Time.new
  puts "#{description} #{stop-start}"
  return result
end

